#!/usr/bin/perl 
# nazwa pliku: finger.pl 
 
use strict; 
use warnings; 
use IO::Socket; 
 
# Iteracja przez kolejne argumenty 
foreach my $input (@ARGV) 
{ 
 
    # Pobierz dane uzytkownika 
    my ($username, $servername) = split /@/, $input; 
 
    # Przypisz pustym zmiennym wartosci domyslne 
    $username = $username || ""; 
    $servername = $servername || "localhost"; 
 
    # Utworz gniazdo 
    my $socket = IO::Socket::INET->new(Proto => "tcp", 
                                       PeerAddr => $servername, 
                                       PeerPort => 79) 
        or die "cannot connect: $! "; 
 
    #Tradycyjna konwencja wymaga podania nazwy hosta w nawiasie 
    print "[$servername]\n"; 
 
    # Wyslij dane do serwera 
    print $socket "$username\n"; 
 
    # Odbierz informacje od serwera 
    print while (<$socket>); 
} 
