#!/usr/bin/perl 
# nazwa pliku: dbi-select.pl 
 
use strict; 
use warnings; 
use DBI; 
 
# Polacz sie z baza danych 
my $username = 'reuven'; 
my $password = ''; 
my $dbh = DBI->connect("DBI:Pg:dbname=coreperl", $username, $password, 
                       {'AutoCommit' => 1, 'PrintError' => 1}) || 
    die "Error connecting: '$DBI::errstr'"; 
 
# Po polaczeniu mozna przygotowac zapytanie  
my $sql = "SELECT first_name, phone_number "; 
$sql .= "FROM AddressBook "; 
$sql .= "ORDER BY first_name "; 
 
# Przygotuj instrukcje 
my $sth = $dbh->prepare($sql) || 
    die "Error preparing: $DBI::errstr"; 
 
# Wykonaj instrukcje 
my $result = $sth->execute || 
    die "Error executing: $DBI::errstr"; 
 
# Przejrzyj po kolei wiersze 
while (my $rowref = $sth->fetchrow_arrayref) 
{ 
    my ($name, $phone) = @{$rowref}; 
    print "$name\t\t$phone\n"; 
} 
 
# Zakoncz zapytanie 
$sth->finish; 
 
# Zakoncz polaczenie z baza danych 
$dbh->disconnect; 
